//Подключение файлов библиотек
#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#include <math.h>
#include <stdint.h>
#include "CA56-12SRWA.h"
#include "DS18b20.h"

//Тактовая частота 4МГц
#define _XTAL_FREQ 4000000 

// CONFIG
#pragma config WDTE = OFF//Сторожевой таймер(защита от зависания) отключен
#pragma config PWRTE = OFF//Сброс до нормализации питающего напряжения отключен
#pragma config BOREN = OFF//Сброс по снижению напряжения питания отключен
#pragma config LVP = OFF//RB4 - порт ввода/вывода, MCLR для программирования
#pragma config CPD = OFF//Защита памяти отключена
#pragma config CP = OFF//Защита кода отключена
#pragma config WRT = OFF// Flash Program Memory Write Enable bits (Write protection off; all program memory may be written to by EECON control)
#pragma config FOSC = XT//Тактирование от внешнего кварца

//USER ID NUMBER //ДАТА ИЗГОТОВЛЕНИЯ ПРОШИВКИ (4 БАЙТА)
#pragma config IDLOC0 =0x01, IDLOC1 = 0x08, IDLOC2 = 0x20, IDLOC3=0x19 

//Основные глобальные переменные
unsigned int time; //1 машинный цикл таймера 0  0...16777216
unsigned int R; //Цифра разряда 0...255
unsigned int A;//Расчет оставшегося времени
unsigned long sec=0; //Секунда 0...4294967296 (138 лет)
int number; //Любое число для печати -32768...32768
unsigned char min=0, hour=0, day=0, programm=0;//Для счетчика в меню
int temperature = 25; //Температура 
unsigned char prev, next, plus, minus;//Кнопки

//Записываются в EEPROM и сохраняется до следующего включения
__eeprom unsigned char sound = 1; //Включен или отключен звук, по умолчанию включен
__eeprom unsigned char ten = 2;//Выбор режима ТЭНов, один верхний или нижний, по умолчанию оба

//Функция обработки прерываний
void __interrupt() timer0()
{
    if (TMR0IE && TMR0IF)//Заполнен таймер 0 и установлен флаг прерывания
    {
        TMR0 = 0;//Обнулить таймер 0
        T0IF = 0;//Снять флаг прерывания
        //Кнопки 
        prev = !RC0;
        minus = !RC1;
        plus = !RC2;
        next = !RC3;
        
    }
    else if (TMR1IE && TMR1IF)//Заполнен таймер 1, установлен флаг прерывания
        {
            TMR1H = 0x86;//Обнуляем таймер
            TMR1L = 0x00;
            TMR1IF = 0;//Снимаем флаг прерывания
            if (time<3){time++;} //Когда натикало, 
            else {time=0; if (sec>0) {sec--;}}//добавляем счетчик
        }
    else if(TMR2IE && TMR2IF)// Если установлен флаг прерывания от совпадения TMR2 и PR2     
    {
        TMR2IF = 0;        // Очистить флаг прерывания TMR2
    }
}

//Зададим вычисление цифры конкретного разряда числа
void razrad(unsigned char rar)
{
    switch (rar) {
        case 1:
            R = number % 10; //Единицы
            break;
        case 2:
            R = number % 100 / 10; //Десятки
            break;
        case 3:
            R = number % 1000 / 100; //Сотни
            break;
        case 4:
            R = number / 1000; //Тысячи
            break;
        default:
            break;

    }
}

//Расчет цифр для печати оставшегося заданного времени
void hour_min(unsigned char u)
{   
    switch (u)
    {
        case 1: //Дни первая цифра
            A=sec/864000;
            if (A==0){A=10;}
            break;
        case 2://Дни вторая цифра
            A=sec/86400%10;
            break;
        case 3://Часы первая цифра
            A=sec%86400/36000;
            if (A==0){A=10;}
            break;
        case 4://Часы вторая цифра
            A=sec%86400/3600%10;
            break;            
        case 5://Минуты первая цифра
            A=sec%86400%3600/600;
            if (A==0 && hour<1){A=10;}
            break;
        case 6://Минуты вторая цифра
            A=sec%86400%3600/60%10;
            if (A==0 && min<1) {A=10;}
            break;
        case 7://Секунды первая цифра
            A=sec%86400%3600%60/10;
            if (A==0 && min<=1){A=10;}
            break;
        case 8://Секунды вторая цифра
            A=sec%86400%3600%60%10;
            break;
            
    }
    
}

//Печатает число(счет разряда, печать разряда)
void obraz (unsigned char a, unsigned char b)
{
    seg(10);
    razrad(a);
    razrad_print(b);
    seg(R);
    __delay_ms(1);
    seg(10);
    return;
}

//Печатает минуты/секунды (печать разряда, расчет цифры)
void dicobraz (unsigned char a, unsigned char b)
{
    seg(10);
    razrad_print(a);
    hour_min(b);
    seg(A);
    __delay_ms(1);
    seg(10);
}

//Печатает символ(печать разряда, печать буквы)
void symbol (unsigned char a, unsigned char b)
{
    seg(10);
    razrad_print(a);
    seg(b);
    __delay_ms(1);
    seg(10);
}
enum {
    TEMP=2,
    MOIS=3,
    MIN=4,
    HOUR=5,
    DAY=6,
    DEFAULT=1
};
//Распознавание числа
void print_number(int razchi, unsigned char type) 
{
    number = razchi;
    razchi=type;
    //Определяем тип печатаемого значения
    /*if (number == temperature)// || number == T1 || number == T2) 
    {razchi = 2;} 
    else if (number == moisture) 
    {razchi = 3;}
    else if (number==min)
    {razchi = 4;}
    else if (number==hour)
    {razchi = 5;}
    else if (number==day)
    {razchi = 6;}
    else {razchi = 1;}*/
   
    //Определяем количество разрядов N    
    unsigned char N; 
    if (number >= 10000) //Для установленного времени либо для нецелого числа
    {N = 5;}
    else if (number >= 1000 && number <= 9999)//Четыре разряда
    {N = 4;} 
    else if (number >= 100 && number <= 999)//Три разряда
    {N = 3;} 
    else if (number >= 10 && number <= 99)//Два разряда
    {N = 2;} 
    else if (number <= 9 && number >= 0)//Один разряд
    {N = 1;} 
    else if (number < 0)//Специально для отрицательной температуры
    {N = 0;}
    
    //Расчет для печати 
    day = sec/86400;
    hour = (sec%86400)/3600;
    min = (sec%86400)%3600;

    switch (razchi) 
    {
        default:
        case 1://Любое число
        {
            switch (N)/*Выполняем только для определенного разряда подряд, 
                                        начиная с определенного случая*/ 
            {
                case 5://Четыре разряда и точка в 2 разряде
                    symbol(0,'.');
                case 4://Четыре разряда
                    obraz(4,4);
                case 3://Три разряда    
                    obraz(3,3);
                case 2://Два разряда 
                    obraz(2,2);
                case 1://Один разряд  
                    obraz(1,1);
                    break;
            }
        }
            break;

        case 2://Температура

        { //Отображение градуса
            symbol(1,'o');
            switch (N) 
            {
                case 2://Температура 2 разряда
                    obraz(2,4);
                case 1: //Температура 1 разряд
                    obraz(1,3);
                    symbol(3,'.');
                    seg(10);
                    razrad_print(2);
                    seg(T2);
                    __delay_ms(1);
                    seg(10);
                    break;
                case 3://Температура 3 разряда
                    obraz(3,4);
                    obraz(2,3);
                    obraz(1,2);
                    break;
                case 0://Отрицательная температура
                    number = abs(temperature);
                    symbol(4,'-');
                    if (number>=10){obraz(2,3);obraz(1,2);}
                    else if (number<10)
                    {
                    obraz(1,3);    
                    symbol(3,'.');
                    seg(10);
                    razrad_print(2);
                    seg(T2);
                    __delay_ms(1);
                    seg(10);
                    }
            }
        }
            break;

        case 3://Влажность
        {
            switch (N) 
            {
                case 2://2 разряда влажности
                    obraz(2,4);
                case 1://1 разряд влажности
                    obraz(1,3);
                    symbol(2,'o');
                    symbol(1,'%');
                    break;
            }
        }
            break;
        case 4://Минуты и секунды
            {
                //Минута 1 цифра
                    if (min>=10) 
                        dicobraz(4,5);
                //Минута 2 цифра   
                    if (TMR1ON == 0) {dicobraz(3,6);}
                    else if (TMR1ON == 1 && sec>=60) {dicobraz(3,6);}
               //Секунда 1 цифра   
                    if (TMR1ON == 0) {symbol(2,'J');}
                    else if (TMR1ON == 1 && sec>=10) {dicobraz(2,7);}
                //Секунда 2 цифра   
                    if (TMR1ON == 0) {symbol(1,'N');}
                    else {dicobraz(1,8);}
            }
            break;
        case 5://Часы
        {
            //2 разряда часов 
            if (hour>=10) {
            dicobraz(4,3);} 
            //1 разряд часов
            dicobraz(3,4);
            symbol(2,4);
            symbol(1,'A');
            
            
        }
            break;
        case 6://Дни
        {
            //2 разряда дней 
            if (day>=10) {
            dicobraz(4,1);}
            //1 разряд дней
            dicobraz(3,2);
            symbol(2,'d');
            symbol(1,'H');
                               
        }
            break;            
    }
}

//Фукция обрабатывает массив букв
void word (unsigned char a, unsigned char b, unsigned char c, unsigned char d)
{
    symbol(4,a);
    symbol(3,b);
    symbol(2,c);
    symbol(1,d);
}

//Печатем слово массивом
void print_word (unsigned char a)
{
    switch (a)
    {
        case 'B'://Выбор
            word('B','W',6,'P');
            break;    
        case 'N'://Пуск
            for (unsigned int y=0; y<500;y++)
            {word('N','Y','C','H');}
            break;
        case 'D'://Датчик
            for (unsigned int x=0; x<500;x++)
            {word('D','A','T',4);}
            break;
        case 'C'://Стоп
            for (unsigned int w=0; w<500;w++)
            {word('C','T','O','N');}
            break;
        case 'P': //Пауза 
            word('N','A','Y',3);
            break;
        case 'E'://Ошибка
            for (unsigned int v=0; v<200;v++)
            {word(10,'E','r','r');}
            break;
        case 'K'://Конец программы
            for (unsigned int q=0; q<500;q++)
            {word(10,'E','n','d');}  
            break;
        case 'O'://Очень горячо, перегрев
            for (unsigned int e=0; e<500;e++)
            {word(10,'H','O','T');}  
            break;
        case 'H'://Приветствие
            {word('H','E','V','O');}
            break;
        case 'S'://DHT11 датчик
            for (unsigned int e=0; e<200;e++)
            {word('D','H','T','V');}
            break;
        case 'G'://ВСЕ?
            {word('B','C','E','?');}
            break;
        case 'T'://ТЭН
            {word('T',3,'H',10);}
            if (ten==0 || (ten <= 100 && ten > 2)) {ten=0; symbol(1,'_');}//Нижний ТЭН
            else if (ten==1){symbol(1,'^');}//Верхний ТЭН
            else if (ten==2 || ten > 100){ten=2; symbol(1,'=');}//Оба ТЭНа
            break;
        case 'Z'://Звук
            if (sound==1)
            {word(3,'B','Y','H');}
            else if (sound==0)
            {word('T','U','H','O');}
            break;
        case 1://Баранина
            {word(6,'A','P','A');}
            break;
        case 2://Говядина
            {word('G','O','B',9);}
            break;    
        case 3://Рыба 
            {word('P','W',6,'A');}
            break;    
        case 4://Тосты 
            {word('T','O','C','T');}
            break;    
        case 5://Курица 
            {word('H','Y','P','W');}
            break;    
        case 6:////Агар-агар стерилизация
            {word('A','G','A','P');}
            break;
        case 7://Посуда стерилизация
            {word('C','T','E','P');}
            break;
        case 8://Пастеризация среды
            {word('N','A','C','T');}
            break;
        case 9://Инкубация агар-агара для проверки на чистоту
            {word('U','A','G','A');}
            break;
        case 10://Посев на воздух
            {word('U','N','O','C');}
            break;
        case 11://Инкубатор куриных яиц
            {word('U','H','Y','P');}
            break;
        case 12://Инкубатор уток, индоуток, индюков, гусей
            {word('U','G','Y','C');}
            break;
        case 13://Инкубатор перепелов
            {word('U','N','E','P');}
            break;
    }
}

//Звукопроигрыватель 
void play (unsigned char music) 
{
    T0IE=0;//Выключить таймер ноль
    if (sound==1){ //Работает, только если не беззвучный режим
    /*Параметры воспроизводимого звука
        a - Длительность первого звука
        b - Обратная частота первого звука
        c - Длительность второго звука
        d - Обратная частота второго звука
        e - Длительность третьего звука
        f - Обратная частота третьего звука
      */
    unsigned int a=0, b=0, c=0, d=0, e=0, f=0, i=0, j=0, m=0, n=0, r=0;
    //Определяем мелодию по параметрам
    switch (music)
    {
        case 'H'://Приветствие 
            a = 130; b = 140; c = 150; d = 53;
            break;
        case 'A'://Предупреждение 
            a = 120; b = 45; c = 100; d = 200;
            break;
        case 'E'://Конец программы
            a = 500; b = 30;
            break;
        case 'B'://Кнопка
            a = 100; b = 105; 
            break;
        case 'S'://Начало программы
            a = 500; b = 20; 
            break;
        case 'P'://Пауза
            a = 100; b = 100; c = 100; d = 50; e = 300; f = 30;
            break;
        case 'D'://Дверка открыта
            //a = ; b = ; c = ; d = ;
            break;
        case 'Z'://Дверка закрыта
             //a = ; b = ; c = ; d = ;
            break;
    }
    PORTAbits.RA4 = 0;
    do {
        j=0;
        if (m<a)
        {
        TRISAbits.TRISA4 = 0;
        for (i=0;i<b;i++){i++;}//Звучание ноты
        TRISAbits.TRISA4 = 1;
        for (i=0;i<b;i++){i++;}//Пауза
        m++;
        }
        else if (m>=a && n<c)
        {
        TRISAbits.TRISA4 = 0;    
        for (i=0;i<d;i++){i++;}//Звучание второй ноты
        TRISAbits.TRISA4 = 1;
        for (i=0;i<d;i++){i++;}//Пауза
        n++;
        }
        else if (m>=a && n>=c && r<e)
        {
        TRISAbits.TRISA4 = 0;    
        for (i=0;i<f;i++){i++;}//Звучание второй ноты
        TRISAbits.TRISA4 = 1;
        for (i=0;i<f;i++){i++;}//Пауза
        r++;
        }
        else if (m>=a && n>=c && r>=e) {j++;}
        }
    while (j<1);
    PORTAbits.RA4 = 1;
    }
    else __delay_ms(200);//Если звук выключен, то просто задержка
    T0IE=1;//Включить таймер 0
}

//Готовые программные режимы
void progs()
{   
    //Указать интервалы возможных программ
    if (programm>13 && programm<=100 ) {programm=1;}
    else if (programm<1 || programm>100){programm=13;}
    
    switch (programm){
    case 1://Баранина
        temperature = 210;
        sec = 2700;//45 минут
        print_word(1);
        break;
    case 2://Говядина
        temperature = 240;
        sec = 2100;//35 минут
        print_word(2);
        break;    
    case 3://Рыба
        temperature = 150;
        sec = 1800;//30 минут
        print_word(3);
        break;  
    case 4://Тосты, сухарики
        temperature = 120;
        sec = 1500;//25 минут
        print_word(4);
        break;      
    case 5://Курица
        temperature = 200;
        sec = 1200;//20 минут
        print_word(5);
        break;      
    case 6://Агар-агар стерилизация
        temperature = 120;
        sec = 1200;//20 минут
        print_word(6);
        break;
    case 7: //Посуда стерилизация
        temperature = 165;
        sec = 7200;// 2 часа
        print_word(7);
        break;
    case 8://Пастеризация среды
        temperature = 75;
        sec = 600;//10 минут
        print_word(8);
        break;
    case 9://Инкубация агар-агара для проверки на чистоту
        temperature = 37;
        sec = 172800;// 2 дня
        print_word(9);
        break;    
    case 10://Посев на воздух
        temperature = 26;
        sec = 604800;//7 дней 
        print_word(10);
        break;    
    case 11://Инкубатор куриных яиц
        temperature = 37;
        sec = 1814400; //21 день 
        print_word(11);
        break;    
    case 12://Инкубатор уток, индоуток, индюков, гусей
        temperature = 37;
        sec = 2419200; //28 дней 
        print_word(12);
        break;
    case 13: //Инкубатор перепелов
        temperature = 37;
        sec = 1468800;//17 дней
        print_word(13);
        break;     
    }
}

void kty ()
{
    int adc_data_raw = 0;//Переменные для считывания данных
    float adc_data = .0f;//Значения уже поправленные
    ADON = 1; //Включение АЦП
    GO = 1;//Старт вычислений
    while(GO);//Ждем окончания вычислений
    adc_data_raw = (unsigned int)ADRESH <<8;//Записываем значения с регистров
    adc_data_raw |= ADRESL;
    adc_data = (float)adc_data_raw;//Необходимо подставить точное значение напряжения!!!
    ADON = 0;//Выключаем АЦП
    T1 = (adc_data-500)/1.8;//Подставляем параметры датчика
}

//Функция показывает температуру, влажность, остаток времени и т.д.
void indicate()
{
    
    if(sec>0)
    {for (unsigned int i=0;i<300;i++)
    {
        if (sec>=86400) 
        {print_number(day,DAY);}
        else if (sec>=3600)
        {print_number(hour,HOUR);}
        else if (sec>0)
        {print_number(min,MIN);}
        else if (sec==0)
        {break;}
    } }
    for (unsigned int k=0;k<400;k++)
    {print_number(T1,TEMP);}
    return;
}

//Функция включения ТЭНов
void heat ()
{   //RC6 - верхний ТЭН, RC7 - нижний ТЭН
    if (ten == 2) //Включаем 2 ТЭНа
    {TRISCbits.TRISC6=0; TRISCbits.TRISC7=0; PORTCbits.RC6=1; PORTCbits.RC7=1; }
    else if (ten == 1) //Включаем верхний ТЭН
    {TRISCbits.TRISC6=0; PORTCbits.RC6=1; }
    else if (ten == 0) //Включаем нижний ТЭН
    {TRISCbits.TRISC7=0; PORTCbits.RC7=1;}
    return;
}

//Функция отключения ТЭНов
void cool()
{
    //RC6 - верхний ТЭН, RC7 - нижний ТЭН
    if (ten == 2) //Выключаем 2 ТЭНа
    {TRISCbits.TRISC6=1; TRISCbits.TRISC7=1; PORTCbits.RC6=0; PORTCbits.RC7=0;}
    else if (ten == 1) //Выключаем верхний ТЭН
    {TRISCbits.TRISC6=1; PORTCbits.RC6=0;}
    else if (ten == 0) //Выключаем нижний ТЭН
    {TRISCbits.TRISC7=1; PORTCbits.RC7=0;}
    return;
}


//Функция терморегуляции
void work ()
{
    switch (sensor)
    {
    case 1: //Гистерезис = 1, датчик подключен 
        black();
        if (T1 <= (temperature-1)) {heat();}
        if (T1 >= (temperature+1)) {cool();}
        else if (T1 > temperature+10){print_word('O'); play('A');}
        break;
    default:
    case 0: //Гистерезис = 5, датчик отключен 
        kty();
        if (T1 <= (temperature-5)) {heat();}
        if (T1 >= (temperature+5)) {cool();}
        else if (T1 > temperature+10){print_word('O'); play('A');}
        break;
    }
    return;    
}

void main() 
{
    GIE = 1; //Глобальные прерывания разрешены    
    PEIE = 1; //Разрешены прерывания от периферийных модулей
    //Таймер 0
    OPTION_REG = 0b00000101; //Предделитель на 64 для таймера 0
    TMR0 = 0;//Сброс счетчика таймера 0  
    T0IF = 0;// Очистить флаг прерывания TMR0
    T0IE = 1;//Включить таймер 0
    //Таймер 1        
    T1CKPS0 = 1;//Предделитель на 8 для таймера 1
    T1CKPS1 = 1; 
    TMR1CS = 0;//Таймер 1 считает от внутреннего генератора 
    T1OSCEN = 0;//Тактовый генератор выключен
    TMR1H = 0x86;//32768
    TMR1L = 0x00;
    TMR1IE = 1; //Включение прерываний таймера 1
    TMR1IF = 0;//Очистить флаг прерываний    
    TMR1ON=0;//Выключим таймер1
    //Таймер 2
    TOUTPS3 = 1;//Выходной делитель 1:16
    TOUTPS2 = 1;
    TOUTPS1 = 1;
    TOUTPS0 = 1;
    T2CKPS1 = 1;//Предделитель 1:16
    T2CKPS0 = 1;
    TMR2IF = 0;// Очистить флаг прерывания TMR2
    TMR2IE = 1;// Включить прерывание TMR2
    TMR2 = 0;//Сброс счетчика таймера 2
    TMR2ON = 0; //Таймер 2 выключен
    //АЦП
    ADCON1 = 0b10000000;//Выравнивание по правому краю, выбор настройки каналов АЦП
    PCFG3 = 0;//Включаем RA0-RA5 как аналоговыe входы
    PCFG2 = 0;
    PCFG1 = 1;
    PCFG0 = 0;
    CHS2 = 1;//Настройка выводов аналогого компаратора на RA5
    CHS1 = 0;
    CHS0 = 0;
    ADCS1 = 1; //Частота тактирования Focs/32
    ADCS0 = 0;
    //Настройка портов
    TRISA = 0b00000000; //Порты А на выход
    TRISB = 0b00000000; //Порты В горят все сегменты
    TRISC = 0b11111111;//Кнопки, ТЭНы, DS18b20, датчик на вход
    PORTA = 0x00; //Порты питание 0В
    PORTB = 0x00; //Порты питание 0В
    PORTC = 0x00;//Порты питание 0В
    //Сброс счетчиков
    time = 0;//Обнуляем счетчики
    sec = 0; //Обнуляем счетчики
    min = 0; //Обнуляем счетчики
    hour = 0; //Обнуляем счетчики 
    day = 0; //Обнуляем счетчики
    temperature = 25;//Обнуляем счетчики
    T2=0;//Обнуляем счетчики
    programm=0;//Обнуляем счетчики
    __delay_ms(300); //Инициализация, пока не включится, нормально не работает
    
    play('H');//Новое приветствие
            
    while (1)//Меню
    {
        goto B;//Идем сразу в главное меню
        Z://Отключение звука
        print_word('Z');//Печать "ЗВУК" или "ТИХО" в зависимости от sound
        if (next) {play('B'); goto Y;} //К настройке ТЭНов
        else if (prev) {play('B'); goto Z;}//Ничего не делать
        else if (plus) {sound=1; play('B');} //Включить звук
        else if (minus) {sound=0;__delay_ms(200);} //Выключить звук 
        goto Z;//Замыкаем цикл
        Y://Выбор ТЭНов
        print_word('T');//Печать "ТЭН_"
        if (next) {play('B'); goto B;} //В главное меню
        else if (prev) {play('B'); goto Z;}//К настройке звука
        else if (plus) {play('B'); ten++;} //Изменяем ТЭНы (переменная ten)
        else if (minus) {play('B'); ten--;} //Изменяем ТЭНы (переменная ten)
        goto Y;//Замыкаем цикл
        B:// Главное меню
        print_word('B');//Печатаем "ВЫБР"
        if (next) {play('B'); goto T;} //К выбору температуры
        else if (prev) {play('B'); goto Y;}//К выбору ТЭНов
        else if (plus) {play('B'); programm++; goto G;} //Выбираем готовые программы
        else if (minus) {play('B'); programm--; goto G;} //Выбираем готовые программы
        goto B;//Замыкаем цикл
        G://Готовые программы
        progs();//Функция меняет параметры нагревания и времени на выбранный режим
        print_word(programm);//Печатаем названия готовых программных режимов
        if (next) {play('B'); goto d;} //К проверке датчика
        else if (prev) {play('B'); temperature=25; sec=0; programm=0; goto B;}//В главное меню
        else if (plus) {play('B'); programm++;}//Меняем программные режимы 
        else if (minus) {play('B'); programm--;}//Меняем программные режимы 
        goto G;//Замыкаем цикл
        T://Выбор температуры(Базовое значение 25 градусов)
        print_number(temperature,TEMP);//Печатаем выбранную температуру
        if  (next) {play('B'); goto M;}//К выбору минут
        else if (prev) {play('B'); temperature=25; goto B;}//В главное меню
        else if (plus) {play('B'); temperature++;}//Меняем температуру
        else if (minus) {play('B'); temperature--;}//Меняем температуру
        goto T;//Замыкаем цикл
        M://Добавляем минуты (Базовое значение 0 минут)
        print_number(min,MIN);//Печатаем количество минут
        if  (next) {play('B'); goto C;}//К выбору часов
        else if (prev) {play('B'); goto T;}//К выбору температуры
        else if (plus) {play('B'); sec+=60;}//Меняем количество минут
        else if (minus) {play('B'); if (sec>=60){sec-=60;}}//Меняем количество минут
        goto M;//Замыкаем цикл
        C://Добавляем часы (Базовое значение 0 часов)
        print_number(hour,HOUR);//Печатаем количество часов
        if  (next) {play('B'); goto D;}//К выбору дней
        else if (prev) {play('B'); goto M;}//К выбору минут
        else if (plus) {play('B'); sec+=3600;}//Меняем количество часов
        else if (minus) {play('B'); if (sec>=3600){sec-=3600;}}//Меняем количество часов
        goto C;//Замыкаем цикл
        D://Добавляем дни (Базовое значение 0 дней)
        print_number(day,DAY);//Печатаем количество дней
        if  (next) {play('B'); goto d;}//К проверке датчика
        else if (prev) {play('B'); goto C;}//К выбору часов
        else if (plus) {play('B'); sec+=86400;}//Меняем количество дней
        else if (minus) {play('B'); if (sec>=86400) {sec-=86400;}}//Меняем количество дней
        goto D;//Замыкаем цикл
        d://Проверка наличия нужного датчика
        black(); 
        //Случай 1: Датчик и температура большая -> ошибка        
        if ((temperature<=-40 || temperature >=125) && sensor) {print_word('E'); play('A'); print_word('D');}
        //Случай 2: Датичка нет, температура маленькая -> ошибка
        if ((temperature>-40 && temperature <125) && !sensor) {print_word('E'); play('A'); print_word('D');}
        //Случай 3,4: Датчики и режимы соответствующие
        if (temperature>-40 && temperature<125 && sensor) {goto N;}//К запуску
        if ((temperature<=-40 || temperature>=125) && !sensor) {goto N;}//К запуску
        else if (prev){play('B'); goto D;}//Для прерывания сигнала отсутствия датчика
        else if (next) {play('B');}//Ничего не делать
        else if (plus) {play('B');}//Ничего не делать
        else if (minus) {play('B');}//Ничего не делать
        goto d;//Замыкаем цикл
        N: //Процедура запуска
        print_word('G');//Предупреждение "ВСЕ?"
        //Если таймер установлен, и нажата кнопка пуск, печатаем "ПУСК"
        if (next && sec>0) {play('S'); print_word('N'); TMR1ON = 1; goto R;}
        //Если таймер не установлен, и нажата кнопка пуск, идем в режим без таймера
        else if (next && sec<60) {play('S'); print_word('N'); goto W;}
        else if (prev){play('B'); sec=0; temperature = 25; goto B;} //Возврат в главное меню   
        else if (plus) {play('B');}//Ничего не делать
        else if (minus) {play('B');}//Ничего не делать
        goto N;//Замыкаем цикл
        R://Нормальный режим работы
        work(); indicate(); black();//Включаем программу терморегуляции, индикации текущих параметров
        /*Если время истекло, выключаем таймер, охлаждаем, 
         *играем "Конец программы", печатаем "СТОП",gока не нажали готово возвращаемся в главное меню*/    
        if (sec==0){TMR1ON = 0; cool(); 
        for (unsigned i=0;i<3;i++) {play('E'); print_word('K');}
        while (!prev && !next){print_word('K'); __delay_ms(200);}
        play('B'); __delay_ms(500); temperature=25; T2=0; goto B;}        
        else if (next) {TMR1ON = 0; play('P');__delay_ms(500); goto P;} //В случае нажатия ставим паузу
        else if (prev){play('B');} //Ничего не делать   
        else if (plus) {play('B');}//Ничего не делать
        else if (minus) {play('B');}//Ничего не делать
        goto R;//Замыкаем цикл
        W://Режим без таймера
        work(); indicate(); black();//Терморегуляция
        if (next) {play('B'); cool(); play('E'); print_word('K'); temperature=25; T2=0; goto B;}//Возврат в главное меню с отключением ТЭНов
        else if (prev){play('B');cool(); play('E'); print_word('K'); temperature=25; T2=0; goto B;} //Возврат в главное меню с отключением ТЭНов    
        else if (plus) {play('B');}//Ничего не делать
        else if (minus) {play('B');}//Ничего не делать
        goto W;//Замыкаем цикл
        P://Режим пауза
        print_word('P');//Печатаем "ПАУЗ"
        if (next){play('S'); print_word('N'); TMR1ON = 1; goto R;} //Возвращаемся с паузы в действие, включаем таймер
        else if (plus) {play('B');}//Ничего не делать
        else if (minus) {play('B');}//Ничего не делать
        //Выход в главное меню со сбросом таймера, счетчика и охлаждением
        else if (prev){sec = 0; TMR1ON = 0; cool(); play('E'); print_word('C'); temperature=25; T2=0; goto B;}
        goto P;//Замыкаем цикл
    }
}


