/*------------------------------------------
 * Функция razrad_print(const)
 * Печатает конкретный разряд числа
 * Для вывода используются порты RA1-RA4 
 * От единиц к тысячам соответственно
 * Остальные порты остаются в положении Вход
 * -----------------------------------------
 * Функция seg(const) 
 * Печатает буквы или цифры, знаки
 * Для вывода используются порты RB0-RB6
 * От сегментов A к сегменту DP соответственно
 * -------------------------------------------*/ 

void razrad_print(unsigned char num)
{

    switch (num) {
        default:
        case 0:
            TRISA = 0b11111111; //Закрыть порт
            break;
        case 1:
            TRISA = 0b11111110; //Единицы
            break;
        case 2:
            TRISA = 0b11111101; //Десятки
            break;
        case 3:
            TRISA = 0b11111011; //Сотни
            break;
        case 4:
            TRISA = 0b11110111; //Тысячи
            break;
    }
}

//Печать цифры, буквы (256 штук максимум)
void seg(unsigned char segment) 
{
    switch (segment) {

        default:
        case 10:
            PORTB = 0b11111111; //Ничего не выводить, если нет такой буквы или цифры
            break;
        case 1:
            PORTB = 0B11111001; //1
            break;
        case 2:
            PORTB = 0B10100100; //2
            break;
        case 3:
            PORTB = 0B10110000; //3, З, Э
            break;
        case 4:
            PORTB = 0B10011001; //4, Ч
            break;
        case 5:                 //5
        case 'S':                //Буква S
            PORTB = 0B10010010; 
            break;
        case 6:
            PORTB = 0B10000010; //6, Б
            break;
        case 'T':               //Буква Г отзеркалена,
        case 7:                 //7
            PORTB = 0B11111000;
            break;
        case 8:
            PORTB = 0B10000000; //8, В
            break;
        case 9:
            PORTB = 0B10010000; //9
            break;
        case 0:                 //0
        case 'O':               //Буква О
            PORTB = 0B11000000;
            break;
        case 11:
            PORTB = 0b00000000; //Зажечь все сегменты
            break;
        case 'A':
            PORTB = 0b10001000; //Буква А
            break;
        case 'B':
            PORTB = 0b10000000; //Буква В
            break;
        case 'b':
            PORTB = 0b10000011; //Буква ь, b
            break;
        case 'C':
            PORTB = 0b11000110; //Буква С
            break;
        case 'c':
            PORTB = 0b10100111; //Буква с
            break;
        case 'D':
            PORTB = 0b10100000;//Буква Д с закорючкой
            break;
        case 'd':
            PORTB = 0b10100001; //Буква d
            break;
        case 'E':
            PORTB = 0b10000110; //Буква Е
            break;
        case 'F':
            PORTB = 0b10001110; //Буква F
            break;
        case 'G':
            PORTB = 0b11001110; //Буква Г
            break;
        case 'H':
            PORTB = 0b10001001; //Буква Н
            break;
        case 'I':
            PORTB = 0b11001111; //Буква I слева
            break;
        case 'J':
            PORTB = 0b11100001; //Буква J
            break;
        case 'L':
            PORTB = 0b11000111; //Буква L
            break;
        case 'N':
            PORTB = 0b11001000; //Буква П
            break;
        case 'n':
            PORTB = 0b10101011; //Буква п, n
            break;
        case '%':
            PORTB = 0b10100011; //Процент нижний
            break;
        case 'o':
            PORTB = 0b10011100; //Процент верхний
            break;
        case 'P':
            PORTB = 0b10001100; //Буква Р
            break;
        case 'q':
            PORTB = 0b10011000; //Буква q
            break;
        case 'r':
            PORTB = 0b10101111; //Буква r, г
            break;
        case 'U':
            PORTB = 0b11000001; //Буква U
            break;
        case 'u':
            PORTB = 0b11100011; //Буква u
            break;
        case 'Y':
            PORTB = 0b10010001; //Буква У
            break;
        case 'V':
            PORTB = 0b11001001;//Две буквы ll
            break;
        case 'W':
            PORTB = 0b10000001;//Буква Ы
            break;
        case '-':
            PORTB = 0b10111111; //Тире 
            break;
        case '_':
            PORTB = 0b11110111; //Нижнее подчеркивание
            break;
        case '=':
            PORTB = 0b11110110;//Верхнее и нижнее подчеркивание
            break;
        case '^':
            PORTB = 0b11111110;//Верхнее подчеркивание
            break;
        case '.':
            PORTB = 0b01111111; //Точка
            break;
        case '?':
            PORTB = 0b00101100;//Вопросительный знак
            break;


    }
}