//Для расчета данных
unsigned char RH1=0, RH2=0, T1=0, T2=0, SUM=0, DHT=0;

//Тактовая частота 4МГц
#define _XTAL_FREQ 4000000 

//Включаем DHT
void DHT_start(){
    TRISCbits.TRISC4 = 0;       // Установить TRISC4 на выход
    PORTCbits.RC4  = 0;         // Установить на RC4 низкий уровень
    __delay_ms(18);             // Ждать 18 мс
    PORTCbits.RC4 = 1;          // Установить на RC4 высокий уровень
    __delay_us(20);             // Ждать 20 мс
    TRISCbits.TRISC4 = 1;       // Установить TRISC4на вход
}

//Ждем ответа от датчика
void DHT_check ()
{
    while (PORTCbits.RC4 & 1);/* wait till bus is High */     
    while(!(PORTCbits.RC4 & 1));/* wait till bus is Low */
    while (PORTCbits.RC4 & 1);/* wait till bus is High */
}

//Считываем данные датчика
unsigned char DHT_read ()
{
    char i,data = 0;  
    for(i=0;i<8;i++)//Считываем 5 байт информации
    {
        while(!(PORTCbits.RC4& 1));  //Ноль - это начало сигнала
        __delay_us(30);         
        if(PORTCbits.RC4 & 1)  //Если сигнал долгий, то "1", иначе "0"
          data = ((data<<1) | 1); 
        else
          data = (data<<1);  
        while(PORTCbits.RC4 & 1);
    }
  return data;
}

//Получаем результаты по вызову
void blue ()
{
   DHT_start();//Стартуем
   DHT_check ();//Проверка ответа
   RH1=DHT_read ();//Записываем результаты измерений
   RH2=DHT_read ();
   T1=DHT_read ();
   T2=DHT_read ();
   SUM=DHT_read ();
   //Если в момент записи результатов произошла ошибка, печатаем ошибку
   if (SUM !=(RH1+RH2+T1+T2)){DHT=0;} 
   else DHT=1;//Датчик есть
   return;
}