/*-----------------------------------------------
 * Порт для передачи данных датчика - RC4,
 * Поменять порт в другом случае на необходимый
 * --------------------------------------------*/

unsigned char T1,T2,sensor=0, init;
//Тактовая частота 4МГц
#define _XTAL_FREQ 4000000 

//Инициализация датчика
unsigned char INIT() {
    unsigned char b;
    TRISCbits.TRISC4 = 1;
    TRISCbits.TRISC4 = 0; //Посылаем запрос
    __delay_us(500); //Ждем 500 мкс
    TRISCbits.TRISC4 = 1; //Переключаемся на вход
    __delay_us(65); //Ждем 65 мкс
    b = RC4; //Смотрим ответ (0-есть датчик, 1-нет датчика)
    __delay_us(450); //Дожидаемся до положенного временного интервала
    return b; //Возвращаем 0 или 1
}

//Функция отправляет команды датчику
void TX(unsigned char cmd) {

    unsigned char temp = 0;
    unsigned char i = 0;
    temp = cmd;
    for (i = 0; i < 8; i++) {
        if (temp & 0x01) {
            TRISCbits.TRISC4 = 0; //передаем 1_delay_us(5);
            TRISCbits.TRISC4 = 1;
            __delay_us(70);
        } else { //передаем 0
            TRISCbits.TRISC4 = 0;
            __delay_us(70);
            TRISCbits.TRISC4 = 1;
            __delay_us(5);
        }
        temp >>= 1;
    }
}

//Функция получает байты информации
unsigned char RX() {

    unsigned char d = 0;
    unsigned char i = 0;
    for (i = 0; i < 8; i++) {
        TRISCbits.TRISC4 = 0; //прижимаем линию
        __delay_us(6);
        TRISCbits.TRISC4 = 1;
        d >>= 1; //освобождаем место под новый бит
        if (RC4 == 1) d |= 0x80; //если 1 то записываем 1
        __delay_us(70); //ждем до положенного времени
    }
    return d;
}

//Функция чтения данных

void black() {
    unsigned char temp1;
    unsigned char temp2;
    init = INIT();
    if (!init) { //успешно инициализировались?
        TX(0xCC);
        TX(0x44);
        __delay_ms(150); //ждем 750 мс
        __delay_ms(150);
        __delay_ms(150);
        __delay_ms(150);
        __delay_ms(150);
        init = INIT(); //повторная инициализация
        if (!init) {
            TX(0xCC);
            TX(0xBE); //команда на чтение
            temp1 = RX(); //читаем младший байт
            temp2 = RX(); //читаем старший байт
        }
        T2 = temp1 & 0b00001111; //Записываем дробную часть в отдельную переменную
        T2 = ((T2 * 6) + 2) / 10; //Переводим в нужное дробное число
        temp1 >>= 4;
        temp2 <<= 4;
        temp2 &= 0b01110000;
        temp2 |= temp1; //помещаем все в одну переменную
        if (temp2 & 0x80) { //если минус
            T1 = 127 - temp2; //глобальная переменная
            T2 = 10 - T2; //глобальная переменная
        }
        else T1 = temp2;
        sensor = 1;
    }
    else {}
    TRISCbits.TRISC4 = 0;
}